<?php

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

// Keeps file coded in UTF-8 without BOM : é

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $ec_conf, $page, $ec_conf_index, $ec_conf_possible_values, $ec_debug;

// ---------------------------------------------------------------------------
//                            $ec_conf initalization
// ---------------------------------------------------------------------------

// $ec_conf has numeric indexes (instead of string keys like 'activated',
// 'howto'...) because of its first reading, done with the "explode" function.
// It would be very easy to build a string keys indexed array, thanks to
// following instructions :
/*
$t = pwg_db_fetch_row(pwg_query("
  SELECT `value`
  FROM `".CONFIG_TABLE."`
  WHERE `param` = 'event_cats';
"));
$ec_conf_temp = explode(',', $t[0]);
$ec_conf = array(); $i = 0;
foreach ($ec_conf_default as $k => $v) $ec_conf[$k] = ec_conf_temp[$i++];
*/
// Though, I prefer to keep $ec_conf with numeric indexes, so to be compelled
// to go through function change_ec_conf() to modify ec_conf, and thus update
// the DB at the same time.

//----------------------------------------------------------------------------
// The following lines allow to change the number of configuration items, the
// default values they can have, and also their possible other values, very
// quickly.

// Give possible $ec_conf values. In case values cannot be predicted, just
// provide an empty array : array() .
$ec_conf_possible_values = array(
  'activated'           => array('0', '1'),                           //  0
  'howto'               => array('0', '1'),                           //  1
  'dup_allow'           => array('0', '1', '2'),                      //  2
  'duplic_display'      => array('0', '1', '2'),                      //  3
  'auto_code_dg_nb'     => array( '4',  '5',  '8', '10', '12', '15',
                                 '16', '20', '24', '25', '30', '32'), //  4
  'unknown_code'        => array('0', '1', '2'),                      //  5
  'unknown_code_ap_id'  => array(),                                   //  6
  'comment_display'     => array('0', '1'),                           //  7
  'in_help_display'     => array('0', '1'),                           //  8
  'display_connection'  => array('0', '1'),                           //  9
  'simple_mode_on'      => array('0', '1'),                           // 10
  'display_full_button' => array('0', '1'),                           // 11
);

// $ec_conf_index is an array of the indexes of $ec_conf. Thus does it allow
// to check if X exists when asking for $ec_conf[X].
$ec_conf_index = array_flip(array_keys($ec_conf_possible_values));

// Get current value of $ec_conf, if the entry in the DB exists.
$t = array(); $u = '0'; $v = false; $w = false; $ec_conf = array(); $s = '0';
if ($w = ( // $w becomes true if the query succeeds <=> if EC was already in
  // $t gets event_cats config value, as an array with one unique entry
  ($t = pwg_db_fetch_row(pwg_query("
    SELECT `value`
    FROM `".CONFIG_TABLE."`
    WHERE `param` = 'event_cats';
  "))) !== false)
) {
  $v = (count($ec_conf = explode(',', $t[0])) == count($ec_conf_index));
  $u = $ec_conf[0];
  $s = ($v) ? $ec_conf[1] : '0'; // the aknowledgement message is displayed
  // again if the configuration changes
}
if ($v and !$w) die('$v true with $w false in ec_conf.inc.php');
// $w is false if the entry in the table doesn't exist;
// $v is false if the entry in the table doesn't exist; or exists, but its
// number of parameters is different than the number of default parameters.
// $u is '0' if the plugin has not yet been activated, '1' if it has been.
// $s allows to display the aknowledgement message when config changes.
// If $v or $w are false, all $ec_conf values are set to default values. But
// default values must first take values specified in $conf, if they are set.

// Determine whether simple mode is ON or OFF
$simple_mode_on = (
  (!$v and !$w) or (
    // $ec_conf[10] <=> read_ec_conf('simple_mode_on')
    isset($ec_conf[10]) and $ec_conf[10] == '1'
  ) or (
    isset($conf['ec_display_full_button']) and
    $conf['ec_display_full_button'] == false
  )
);

if (!$v) {
  // Give configuration items names and default values. Only strings.
  $ec_conf_default = array( // PLUGIN CONFIGURATION ($ec_conf) :
                            // ---------------------------------
    'activated'       //  0 // plugin activated, 0 or 1
      => $u,                // 
                            // 
    'howto'           //  1 // whether the small aknowledgement message has
      => $s,                // already been displayed, 0 or 1
                            // 
    'dup_allow' => ($simple_mode_on and isset($conf['ec_dup_allow']) and
                    in_array($conf['ec_dup_allow'],
                    $ec_conf_possible_values['ec_dup_allow'])) ?
      $conf['ec_dup_allow'] : (isset($ec_conf[2]) and in_array($ec_conf[2],
      $ec_conf_possible_values['dup_allow'])) ? $ec_conf[2] : '2',
                      //  2 // duplication allowance :
                            //   0 : no account;
                            //   1 : all accounts;
                            //   2 : specified by group, type, and user ids.
                            // If Event Cats is in "simple mode", takes the
                            // value of $conf['ec_dup_allow'] if it is set;
                            // and an allowance to duplicate only generic
                            // accounts will be defined.
                            // 
    'duplic_display' => ($simple_mode_on and isset($conf['ec_duplic_display'])
                    and in_array($conf['ec_duplic_display'],
                    $ec_conf_possible_values['ec_duplic_display'])) ?
      $conf['ec_duplic_display'] : (isset($ec_conf[3]) and
      in_array($ec_conf[3], $ec_conf_possible_values['duplic_display'])) ?
      $ec_conf[3] : '2',
                      //  3 // duplication link display in the menubar :
                            //   0 : "Register" for everybody;
                            //   1 : "Duplicate" for everybody;
                            //   2 : "Register" only for generic accounts,
                            //       "Duplicate" for all other accounts;
                            // If Event Cats is in "simple mode", takes the
                            // value of $conf['ec_duplic_display'] if it's set.
                            // 
  'auto_code_dg_nb' => ($simple_mode_on and isset($conf['ec_auto_code_dg_nb'])
                    and in_array($conf['ec_auto_code_dg_nb'],
                    $ec_conf_possible_values['ec_auto_code_dg_nb'])) ?
      $conf['ec_auto_code_dg_nb'] : (isset($ec_conf[4]) and
      in_array($ec_conf[4], $ec_conf_possible_values['auto_code_dg_nb'])) ?
      $ec_conf[4] : '10',
                      //  4 // number of digits when creating a new code
                            // automatically, several values
                            // If Event Cats is in "simple mode", takes the
                            // value of $conf['ec_auto_code_dg_nb'] if set.
                            // 
    'unknown_code'    //  5 // what to do in case an unknown code is used with
      => (isset($ec_conf[5]) and in_array($ec_conf[5],
      $ec_conf_possible_values['unknown_code'])) ? $ec_conf[5] : '1',
                            // "autolog" parameter :
                            //   0 : nothing (display home page, index.php
                            //       (not logged in of course));
                            //   1 : display "access denied" page;
                            //   2 : display an A. P. precised below.
                            // 
    'unknown_code_ap_id' // 6| the id of the Additional Page which must be
      => (isset($ec_conf[6])) ? $ec_conf[6] : '0',
                            // used in case of usage of an unknow code;
                            // several vals.
                            // 
    'comment_display' => ($simple_mode_on and isset($conf['ec_comment_display'])
                    and in_array($conf['ec_comment_display'],
                    $ec_conf_possible_values['ec_comment_display'])) ?
      $conf['ec_comment_display'] : (isset($ec_conf[7]) and
      in_array($ec_conf[7], $ec_conf_possible_values['comment_display'])) ?
      $ec_conf[7] : '1',
                      //  7 // the way the comment is displayed in "entries"
                            // tab : 0, as tooltip; 1, on a line under code
                            // If Event Cats is in "simple mode", takes the
                            // value of $conf['ec_comment_display'] if set.
                            // 
    'in_help_display' //  8 // whether the help banner is displayed.
      => (isset($ec_conf[8]) and in_array($ec_conf[8],
      $ec_conf_possible_values['in_help_display'])) ? $ec_conf[8] : '1',
                            // 0: not displayed; 1 : displayed (surprising !)
                            // 
    'display_connection' => ($simple_mode_on and
                    isset($conf['ec_display_connection']) and
                    in_array($conf['ec_display_connection'],
                    $ec_conf_possible_values['ec_display_connection'])) ?
      $conf['ec_display_connection'] : (isset($ec_conf[9]) and
      in_array($ec_conf[9], $ec_conf_possible_values['display_connection'])) ?
      $ec_conf[9] : '1',
                      //  9 // whether the "Connection" link must be displayed
                            // for generic users, 0 or 1.
                            // If Event Cats is in "simple mode", takes the
                            // value of $conf['ec_display_connection'] if set.
                            // 
    'simple_mode_on' => ($simple_mode_on) ?
      '1' : '0',      // 10 // whether the presentation of the plugin is in
                            // "simple mode" or not.
                            // 0: normal view; 1 : simple view.
                            // The default value can be modified to 0 (normal
                            // view) if Event Cats was already installed
                            // previously.
                            // 
    'display_full_button' => ($simple_mode_on and
                    isset($conf['ec_display_full_button']) and
                    in_array($conf['ec_display_full_button'],
                    $ec_conf_possible_values['ec_display_full_button'])) ?
      $conf['ec_display_full_button'] : (isset($ec_conf[11]) and
    in_array($ec_conf[11], $ec_conf_possible_values['display_full_button'])) ?
       $ec_conf[11] : '1',
                      // 11 // whether the "Show full features" button must be
                            // displayed, 0 or 1. The default value can be
                            // modified to 0 (don't display) if
                            // $conf['ec_display_full_button'] has val. false.
  );
  
// Once these lines have been updated, you don't need to change anything
// else. Everything is managed by the code.
//----------------------------------------------------------------------------

  // Set $ec_conf to proper default values if needed, and writes its values
  // in the DB
  $ec_conf = array_values($ec_conf_default);

  change_ec_conf('activated', $u); // writes in the DB
}
// now :
//   _ the number of parameters is the same in the DB as the number of
//     default parameters;
//   _ the parameters have the default values if needed;
//   _ the plugin shows it is active if it is the case;
//   _ correct values will be returned when using procedure read_ec_conf($c).

unset($t, $u, $v, $w, $simple_mode_on);
// And NOW can change_ec_conf and read_ec_conf be used properly...

// ---------------------------------------------------------------------------
//                  End of $ec_conf initalization
// ---------------------------------------------------------------------------

/*
 * change_ec_conf($c, $v)
 * updates Event Cats configuration values in the database as well as in
 * $ec_conf.
 *
 * @param
 *   $c : conf value to update;
 *   $v : value to give to $ec_conf[$c].
 * @return
 *   true or false whether the change was OK or not
 */
function change_ec_conf($c, $v) {
  global $ec_conf, $page, $ec_conf_index, $ec_conf_possible_values;

  if (array_key_exists($c, $ec_conf_index)) {
    if (
      count($ec_conf_possible_values[$c]) == 0 or
      in_array($v, $ec_conf_possible_values[$c])
    ) {
      $ec_conf[$ec_conf_index[$c]] = $v;
      return ($a=(pwg_query("
        UPDATE `".CONFIG_TABLE."`
        SET `value` = \"".implode(',', $ec_conf)."\"
        WHERE `param` = 'event_cats';
      ") !== false));
    }
    else {
      $page['errors'][] = 'Bad change_ec_conf value';
      return false;
    }
  }
  else {
    $page['errors'][] = 'Bad change_ec_conf index';
    return false;
  }
}

/*
 * read_ec_conf($c)
 * returns the value in $ec_conf using string keys.
 *
 * @param
 *   $c : conf value to update;
 * @return
 *   $ec_conf value
 */
function read_ec_conf($c) {
  global $ec_conf, $page, $ec_conf_index;
  if (array_key_exists($c, $ec_conf_index))
   return $ec_conf[$ec_conf_index[$c]];
  else {
    $page['errors'][] = 'Bad read_ec_conf index';
    return false;
  }
}

?>